

SCREEN _NEWIMAGE(640, 480, 32) ' Set screen, resolution 640*480, 32 bit

DIM SHARED guyframe AS DOUBLE ' frame will be used to flag the current frame of Guybrush
DIM SHARED guybrush_x AS DOUBLE ' this variable will be used to flag the x position of Guybrush
DIM SHARED walk_by_time AS DOUBLE, start_walk_time AS DOUBLE ' these two variables will be used to flag
															 ' the pass-by time of Guybrush
                                                           
DIM SHARED loop_time AS DOUBLE, this_time AS DOUBLE, tb_movement_factor AS DOUBLE ' variables related to time-based movement
' loop_time -> time passed between two consecutive loops (current time - time in previous loop)
' this_time -> variable used to flag the start time of the previous loop
' tb_movement_factor -> a factor that multiplies with every movement/timing variable in the game
' if you want to sync-it with 60 FPS (make it equal 1 if the game runs 60 FPS), you multiply loop_time
' with 60

' FPS related variables
DIM frames_per_sec AS INTEGER
DIM fps AS INTEGER
DIM start_time AS DOUBLE
DIM timer_elapsed AS DOUBLE

start_walk_time = TIMER ' Initial values of our timing variables
loop_time = TIMER - this_time
this_time = TIMER

guyframe = 1
guybrush_x = -120

' Load the Guybrush frames into a memory buffer
frames& = _LOADIMAGE("frames.bmp")

DO


    loop_time = TIMER - this_time ' calculate time between two loops
    this_time = TIMER ' set the current loop time
    tb_movement_factor = loop_time * 60 ' adjust movement factor to 60 FPS
    ' (if the program runs 60 FPS, tb_movement_factor will be 1)

    guyframe = guyframe + 0.09 * tb_movement_factor ' frame rotation (note how the speed of rotation is
    ' multiplied with tb_movement_factor)
    IF guyframe > 6.5 THEN guyframe = 0.51 ' loop the frames (6 frames)

    guybrush_x = guybrush_x + 2 * tb_movement_factor ' movement formula
    IF guybrush_x > 660 THEN
        walk_by_time = TIMER - start_walk_time ' when Guybrush goes off screen
        start_walk_time = TIMER ' calculate walk-by time, reset the timer,
        guybrush_x = -120 ' set him back on the left side of the screen
    END IF

    LINE (0, 0)-(639, 479), _RGB(255,255,255), BF ' Color the background white
	_PUTIMAGE (guybrush_x, 140), frames&, 0, (3 + (CINT(guyframe) - 1) * 104, 0)-(103 + (CINT(guyframe)- 1) * 104, 155)	
	' Paste the proper Guybrush frame on the screen
	
    ' Print some variables on the screen.
    LOCATE 1, 1
    PRINT "FPS:"; fps
    PRINT "time-based factor:"; tb_movement_factor
    PRINT "walk-by time:"; walk_by_time

    '_LIMIT 60 ' Rem/unrem to test different FPS
    _DISPLAY

    frames_per_sec = frames_per_sec + 1 ' count loops
    timer_elapsed = (TIMER - start_time) ' calculate when one second passes
    IF timer_elapsed > 1 THEN
        fps = frames_per_sec / timer_elapsed ' when one second passes calculate FPS
        frames_per_sec = 0 ' reset loop counter
        start_time = TIMER ' reset start time (for 1 second formula)
    END IF

LOOP UNTIL INKEY$ <> "" 
